<?php

/**
* Clase Dispacher para Documento
*
* @package IM
* @subpackage DocumentoDP
* @author Willy
* @version SVN: : DocumentoDP.class.php,v 1.1 2009/05/23 00:01:50 Exp $
*/
class DocumentoDP implements interfaceDP {

  protected $o_Bean;

  /**
  * Constructor donde asigna a un atributo el objeto DocumentoBean
  *
  * @param DocumentoBean $o_DocumentoBean
  */
  public function __construct(DocumentoBean $o_DocumentoBean){
  
    $this->o_Bean = $o_DocumentoBean;
    
  }
  
  /**
  * Retorna el objeto DocumentoBean
  *
  * @return Object
  */
  protected function getObjetoBean(){
  
    if(!$this->o_Bean){
        $this->o_Bean = new DocumentoBean();
    }        
    return $this->o_Bean;
    
  }
  
  /**
  * Ingresa un nuevo registro
  *
  * @return IdGenerado
  */
  
  public function save(){
    $con = Conexion::getConexion();
      $a_Fields = array();
      
      if($this->getObjetoBean()->getIdDocumento()) : $a_Fields['IdDocumento'] = ($this->getObjetoBean()->getIdDocumento()); endif;
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;     
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;     
  
      
      $sStringField = arrayClass::implode_keys(',', $a_Fields);
      $sStringValue = "'".implode("','", $a_Fields)."'";

      $sql = "INSERT INTO cr_documento (".$sStringField.")
                      VALUES (".$sStringValue.");";
       //echo $sql;
      $iResultSave = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      mysql_close($con);
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }
  
  }
  
  
  /**
  * Modifica un nuevo registro
  *
  * @return IdGenerado
  */
  
   public function update() {

    if($this->getObjetoBean()->getIdDocumento()){
      $con = Conexion::getConexion();
      $a_Fields = array();
      if($this->getObjetoBean()->getIdDocumento()) : $a_Fields['IdDocumento'] = ($this->getObjetoBean()->getIdDocumento()); endif;
      if($this->getObjetoBean()->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getObjetoBean()->getDescripcion()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;     
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;     
      
      $sString = arrayClass::implode_key_value(",", $a_Fields);

      $sql = "UPDATE cr_documento SET
                  ".$sString."
            WHERE 1 AND IdDocumento= '".$this->getObjetoBean()->getIdDocumento()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      mysql_close($con);
      //echo $sql;           
      $iResultSave = $result;
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }

    }else{
      return false;
    }

  }
  
  
  /**
  * Elimina registro
  *
  * @return Boolean
  */
  public function delete(){
    
      $o_Documento = new DocumentoBean();
      
      $con = Conexion::getConexion();
      
      if($this->getObjetoBean()->getIdDocumento()){
          $o_Documento->setIdDocumento($this->getObjetoBean()->getIdDocumento());
      }
            
      $sql = "UPDATE cr_documento 
              SET
                Eliminado = '1',
                FechaEliminado = '".date('Y-m-d H:i:s')."',
                UsuarioEliminado = '".$this->getObjetoBean()->getUsuarioEliminado()."'
            WHERE IdDocumento = '".$this->getObjetoBean()->getIdDocumento()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      
      $num_rows = mysql_affected_rows($con);
      mysql_close($con);
                  
      $iResultDelete = $num_rows;
      if($iResultDelete){
          return 1;
      }else{
          return false;
      }    
    
  }
  /**
  * Selecciona un nuevo registro
  *
  * @return IdGenerado
  */
  public function select(){
      
    $where = "";
        
    $tamPag           = is_null($this->getObjetoBean()->tamPag)?999999:$this->getObjetoBean()->tamPag;
    $pagina           = is_null($this->getObjetoBean()->page)?1:$this->getObjetoBean()->page;
    $numeroRegistros  = $this->selectNumRows();
    $limitInf         = ($pagina-1)*$tamPag;
    
    $where = $this->buildConsult();
    //$orden = $this->buildOrderByField();
    if(trim($orden) =='') $orden = "ORDER BY IdDocumento DESC";
    $con = Conexion::getConexion();
    $sql = "SELECT * FROM cr_documento
            WHERE Eliminado <> '1' ".$where." ".$orden." LIMIT ".$limitInf.",".$tamPag;
    //echo $sql;
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    //echo $sql;
    $a_tmp = array();

    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      $a_tmp[] = $this->insertarObjetoBean($o_valor);
      }
    }

    mysql_close($con);
   
    return count($a_tmp)>0?$a_tmp:null;
      
  }  
  
  
  /**
  * Retorna un objeto DocumentoBean
  *
  * @return Object
  */
   public function selectByPk(){
  
    $con = Conexion::getConexion();
    $sql = "SELECT * FROM cr_documento WHERE 1 and IdDocumento='".$this->getObjetoBean()->getIdDocumento()."' ";
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $o_Propel = $result ? mysql_fetch_object($result) : null;
    mysql_close($con);
    echo $sql;
    return $o_Propel?$this->insertarObjetoBean($o_Propel):null;
  
  }
  
  /**
  * Reasigna valores retornados del propel a un objeto DocumentoBean
  *
  * @param Object $o_Propel
  * @return DocumentoBean
  */
  private function insertarObjetoBean($o_Propel){

    $o_DocumentoBean = new DocumentoBean();
    
    $o_DocumentoBean->setIdDocumento($o_Propel->IdDocumento);
    $o_DocumentoBean->setDescripcion($o_Propel->Descripcion);
    $o_DocumentoBean->setEstado($o_Propel->Estado);
    $o_DocumentoBean->setEliminado($o_Propel->Eliminado);
    $o_DocumentoBean->setUsuarioCreacion($o_Propel->UsuarioCreacion);
    $o_DocumentoBean->setFechaCreacion($o_Propel->FechaCreacion);
    $o_DocumentoBean->setUsuarioModificacion($o_Propel->UsuarioModificacion);
    $o_DocumentoBean->setFechaModificacion($o_Propel->FechaModificacion);
    $o_DocumentoBean->setFechaEliminado($o_Propel->FechaEliminado);
    $o_DocumentoBean->setFechaEliminado($o_Propel->UsuarioEliminado);
         
    return $o_DocumentoBean;    
    
  }
  
   public function selectNumRows(){
    
    $where = $this->buildConsult();
    
    $con = Conexion::getConexion();
    
    $sql = "SELECT * FROM cr_documento WHERE Eliminado <> '1'".$where;
   
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    mysql_close($con);
    //echo $sql;
    return $num_rows;
    
  }
  
  private function buildConsult(){
    
    $where = "";
    
    if($this->getObjetoBean()->getIdDocumento()){
       $where .= " AND IdDocumento  = '".$this->getObjetoBean()->getIdDocumento()."'";
    }
    
    if($this->getObjetoBean()->getDescripcion()){
       $where .= " AND Descripcion like '%".$this->getObjetoBean()->getDescripcion()."%'";
    }
    if($this->getObjetoBean()->getEstado()){
        $where .= " AND Estado  = '".$this->getObjetoBean()->getEstado()."'";
    }
    
    return $where;
    
  }
    
}

